<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">

<html>

<head>

<meta http-equiv="content-type" content="text/html; charset=iso-8859-1">

<title>Debian Perl Policy - Packaged Modules</title>

<link href="index.html" rel="start">
<link href="ch-site.html" rel="prev">
<link href="ch-programs.html" rel="next">
<link href="index.html#contents" rel="contents">
<link href="index.html#copyright" rel="copyright">
<link href="ch1.html" rel="chapter" title="1 About this document">
<link href="ch-perl.html" rel="chapter" title="2 Perl Packaging">
<link href="ch-site.html" rel="chapter" title="3 Locally Installed Modules">
<link href="ch-module_packages.html" rel="chapter" title="4 Packaged Modules">
<link href="ch-programs.html" rel="chapter" title="5 Perl Programs">
<link href="ch-embed.html" rel="chapter" title="6 Programs Embedding Perl">
<link href="ap-perl6.html" rel="appendix" title="A Perl 6">
<link href="ch-perl.html#s-versions" rel="section" title="2.1 Versions">
<link href="ch-perl.html#s-base" rel="section" title="2.2 Base Package">
<link href="ch-perl.html#s-paths" rel="section" title="2.3 Module Path">
<link href="ch-perl.html#s-docs" rel="section" title="2.4 Documentation">
<link href="ch-site.html#s-site_dirs" rel="section" title="3.1 Site Directories">
<link href="ch-site.html#s-site_install" rel="section" title="3.2 Site Installation">
<link href="ch-module_packages.html#s-vendor_dirs" rel="section" title="4.1 Vendor Directories">
<link href="ch-module_packages.html#s-package_names" rel="section" title="4.2 Module Package Names">
<link href="ch-module_packages.html#s-vendor_install" rel="section" title="4.3 Vendor Installation">
<link href="ch-module_packages.html#s-module_deps" rel="section" title="4.4 Module Dependencies">
<link href="ch-programs.html#s-hash_bang" rel="section" title="5.1 Script Magic">
<link href="ch-programs.html#s-program_deps" rel="section" title="5.2 Program Dependencies">
<link href="ch-embed.html#s-build_embedded" rel="section" title="6.1 Building Embedded Programs">
<link href="ch-embed.html#s-embedded_deps" rel="section" title="6.2 Embedded Perl Dependencies">
<link href="ch-embed.html#s-perl_upgrades" rel="section" title="6.3 Perl Package Upgrades">
<link href="ch-module_packages.html#s-indep_modules" rel="subsection" title="4.4.1 Architecture-Independent Modules">
<link href="ch-module_packages.html#s-binary_modules" rel="subsection" title="4.4.2 Binary and Other Architecture Dependent Modules">
<link href="ch-module_packages.html#s-dh_perl" rel="subsection" title="4.4.3 Automating Perl Dependencies">

</head>

<body>

<p><a name="ch-module_packages"></a></p>
<hr>

<p>
[ <a href="ch-site.html">previous</a> ]
[ <a href="index.html#contents">Contents</a> ]
[ <a href="ch1.html">1</a> ]
[ <a href="ch-perl.html">2</a> ]
[ <a href="ch-site.html">3</a> ]
[ 4 ]
[ <a href="ch-programs.html">5</a> ]
[ <a href="ch-embed.html">6</a> ]
[ <a href="ap-perl6.html">A</a> ]
[ <a href="ch-programs.html">next</a> ]
</p>

<hr>

<h1>
Debian Perl Policy
<br>Chapter 4 - Packaged Modules
</h1>

<hr>

<h2 id="s-vendor_dirs">4.1 Vendor Directories</h2>

<p>
The installation directory for Debian modules must be different from that for
<var>core</var> and <var>site</var> modules.
</p>

<p>
The current Perl packaging uses the <var>vendor</var> directories for this
purpose, which are at present as described in <a
href="ch-perl.html#s-paths">Module Path, Section 2.3</a> as <var>vendor</var>.
</p>

<p>
No version subdirectory exists on these directories as the dependencies for
packaged modules (see <a href="#s-module_deps">Module Dependencies, Section
4.4</a>) should ensure that all work with the current <code>perl</code>
package.
</p>

<p>
The Perl distribution includes many modules available separately from CPAN[<a
href="footnotes.html#f6" name="fr6">6</a>], which may have a newer version.
The intent of the <samp>@INC</samp> ordering (described in <a
href="ch-perl.html#s-paths">Module Path, Section 2.3</a>) is to allow such
modules to be packaged to <var>vendor</var> which take precedence over the
version in <var>core</var>.  A packaged module which shadows a <var>core</var>
module in this way must be a newer version.
</p>

<p>
Module packages must install manual pages into the standard directories (see <a
href="ch-perl.html#s-docs">Documentation, Section 2.4</a>) using the extensions
<samp>.1p</samp> and <samp>.3pm</samp> to ensure that no conflict arises where
a packaged module duplicates a <var>core</var> module.
</p>

<p>
<code>.packlist</code> files should not be installed.
</p>

<hr>

<h2 id="s-package_names">4.2 Module Package Names</h2>

<p>
Perl module packages should be named for the primary module provided.  The
naming convention is to lowercase the Perl module name, prepend,
<samp>lib</samp>, change all occurrences of <samp>::</samp> to <samp>-</samp>,
and append <samp>-perl</samp>.  For example:
</p>

<pre>
     Foo::Bar        libfoo-bar-perl
     Foo::Bar::Baz   libfoo-bar-baz-perl
     Foo::BarBaz     libfoo-barbaz-perl
</pre>

<p>
Packages which include multiple modules may additionally include provides for
the additional modules using the same convention.
</p>

<hr>

<h2 id="s-vendor_install">4.3 Vendor Installation</h2>

<p>
A module should use the following lines in the <code>debian/rules</code>
<samp>build</samp> target[<a href="footnotes.html#f7" name="fr7">7</a>]:
</p>

<pre>
     perl Makefile.PL INSTALLDIRS=vendor
     $(MAKE) OPTIMIZE=&quot;-O2 -g -Wall&quot;
</pre>

<p>
and this one to install the results into the temporary tree:
</p>

<pre>
     $(MAKE) install DESTDIR=$(CURDIR)/debian/&lt;tmp&gt;
</pre>

<p>
[<a href="footnotes.html#f8" name="fr8">8</a>]
</p>

<hr>

<h2 id="s-module_deps">4.4 Module Dependencies</h2>

<hr>

<h3 id="s-indep_modules">4.4.1 Architecture-Independent Modules</h3>

<p>
Architecture-independent modules which require <var>core</var> modules from the
<code>perl</code> package must specify a dependency on that package.
</p>

<p>
Modules which contain explicit <samp>require <var>version</var></samp> or
<samp>use <var>version</var></samp> statements must specify a dependency on
<code>perl</code> or <code>perl-base</code> with the minimum required version,
or more simply the current version.
</p>

<hr>

<h3 id="s-binary_modules">4.4.2 Binary and Other Architecture Dependent Modules</h3>

<p>
Binary modules must specify a dependency on either <code>perl</code> or
<code>perl-base</code> with a minimum version of the <code>perl</code> package
used to build the module.  Additionally, all binary modules (regardless of
their installation directory) and any other modules installed into
<samp>$Config{vendorarch}</samp> must depend on the expansion of
<code>perlapi-$Config{debian_abi}</code> using the <samp>Config</samp> module.
If <samp>$Config{debian_abi}</samp> is empty or not set,
<samp>$Config{version}</samp> must be used.
</p>

<hr>

<h3 id="s-dh_perl">4.4.3 Automating Perl Dependencies</h3>

<p>
Rather than hard-coding the dependencies into the control file, using a
substitution such as <samp>${perl:Depends}</samp> is suggested.  This allows
the dependencies to be determined at build time and written to the
<code>substvars</code> file in the form
<samp>perl:Depends=<var>deps</var></samp>.[<a href="footnotes.html#f9"
name="fr9">9</a>]
</p>

<p>
Packages built with <code>debhelper</code> may use <code>dh_perl(1)</code> to
generate this substitution automatically.  This additionally requires a
versioned <samp>Build-Depends</samp> (or <samp>Build-Depends-Indep</samp>) on
<samp>debhelper (&gt;= 3.0.18)</samp>.
</p>

<hr>

<p>
[ <a href="ch-site.html">previous</a> ]
[ <a href="index.html#contents">Contents</a> ]
[ <a href="ch1.html">1</a> ]
[ <a href="ch-perl.html">2</a> ]
[ <a href="ch-site.html">3</a> ]
[ 4 ]
[ <a href="ch-programs.html">5</a> ]
[ <a href="ch-embed.html">6</a> ]
[ <a href="ap-perl6.html">A</a> ]
[ <a href="ch-programs.html">next</a> ]
</p>

<hr>

<p>
Debian Perl Policy
</p>

<address>
version 3.9.8.0, 2016-03-30<br>
<br>
Rapha&euml;l Hertzog<br>
Brendan O'Dea<br>
The Debian Policy mailing list <code><a href="mailto:debian-policy@lists.debian.org">mailto:debian-policy@lists.debian.org</a></code><br>
<br>
</address>
<hr>

</body>

</html>

